#################################################
#
#  (C) 2017 Slávek Banko
#  slavek (DOT) banko (AT) axis.cz
#
#  Improvements and feedback are welcome
#
#  This file is released under GPL >= 2
#
#################################################

add_subdirectory( common )
add_subdirectory( effects )
add_subdirectory( mixers )
add_subdirectory( synth )

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/arts/gui/common
  ${CMAKE_BINARY_DIR}/arts/midi
  ${CMAKE_BINARY_DIR}/arts/modules/common
  ${CMAKE_BINARY_DIR}/arts/modules/effects
  ${CMAKE_BINARY_DIR}/arts/modules/mixers
  ${CMAKE_BINARY_DIR}/arts/modules/synth
  ${CMAKE_BINARY_DIR}/arts/runtime
  ${CMAKE_BINARY_DIR}
  ${ARTS_INCLUDE_DIRS}
  ${TQT_INCLUDE_DIRS}
  ${TDE_INCLUDE_DIR}
)

link_directories(
  ${TQT_LIBRARY_DIRS}
  ${ARTS_LIBRARY_DIRS}
)


##### artsmodules (library) #####################

tde_add_library( artsmodules SHARED
  SOURCES
    artsmodules.cpp
  VERSION 0.0.0
  LINK
    tdecore-shared ${DL_LIBRARIES} mcop artsflow
    artsbuilder-shared artsgui_idl-shared artsmidi_idl-shared
    artsmodulescommon-shared artsmodulessynth-shared
    artsmoduleseffects-shared artsmodulesmixers-shared
  DESTINATION ${LIB_INSTALL_DIR}
)

add_custom_command(
  OUTPUT
    artsmodules.cpp artsmodules.h
    artsmodules.mcoptype artsmodules.mcopclass
  COMMAND ${ARTS_MCOPIDL_EXECUTABLE} -t
    -I${CMAKE_SOURCE_DIR}/arts/gui/common
    -I${CMAKE_SOURCE_DIR}/arts/midi
    -I${CMAKE_SOURCE_DIR}/arts/modules
    -I${CMAKE_SOURCE_DIR}/arts/modules/common
    -I${CMAKE_SOURCE_DIR}/arts/modules/effects
    -I${CMAKE_SOURCE_DIR}/arts/modules/mixers
    -I${CMAKE_SOURCE_DIR}/arts/modules/synth
    -I${ARTS_INCLUDEDIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/artsmodules.idl
  DEPENDS artsmodules.idl
)


##### other data ################################

install(
  FILES
    artsmodules.idl
    ${CMAKE_CURRENT_BINARY_DIR}/artsmodules.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/arts
)

install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/artsmodules.mcoptype
    ${CMAKE_CURRENT_BINARY_DIR}/artsmodules.mcopclass
  DESTINATION ${LIB_INSTALL_DIR}/mcop
)
